<?php

/*
* pdf2swf pour PHP 4
* franck ruzzin
* 08 avril 2010
*/

class Pdf2swf
{
	//Chemin de pdf2swf avec "/" terminal
	var $pdftoolsPath;
	
	/**
	* Constructeur
	*/
	function Pdf2swf()
	{
		$serverOS=strtoupper($_ENV['OS']);
		$pos = strpos($serverOS, "WINDOWS");
		//Le systeme du serveur n'est pas Windows
		if ($pos === false) {
			$this->pdftoolsPath='../';
		} else {
		//Le systeme du serveur est  Windows
			$this->pdftoolsPath='..\\';
		}
	}
		
	/**
	* Mthode pour convertir pour convertir un PDF en SWF
	* @param string $pdfFilePath chemin complet vers le fichier PDF
	* @param string $swfFilePath chemin complet vers le fichier SWF
	* @return boolean "true" si le fichier existe, "false" sinon ou s'il y a un problme de paramtre
	*/
	function convert($pdfFilePath,$swfFilePath)
	{	
		$output=array();
		if (!file_exists($pdfFilePath)) {
			array_push ($output, utf8_encode("Ne trouve pas $pdfFilePath"));
			array_push ($output, "EXEC RETURN VALUE : 1");
			return $this->arrayToString($output);
		}
		if ($swfFilePath==null) {
			array_push ($output, utf8_encode("Nom du fichier de sortie non fix"));
			array_push ($output, "EXEC RETURN VALUE : 1");
			return $this->arrayToString($output);
		}
		//si le fichier PDF est plus ancien que le fichier SWF. Donc le SWF requis existe dj.
		if (!$this->isPdfNewer($pdfFilePath,$swfFilePath)) {
			array_push ($output, utf8_encode("Fichier de sortie dj  jour"));
			array_push ($output, "EXEC RETURN VALUE : 0");
			return $this->arrayToString($output);
		}
		// Supprimer l'ventuel fichier
        //if (file_exists($swfFilePath)) unlink($swfFilePath);
		// Cration d'un SWF  partir d'un PDF  
		$command = $this->pdftoolsPath . 'pdf2swf ' . $pdfFilePath . ' -o ' . $swfFilePath . ' -s internallinkfunction=handleInternalLink -T 9';
		$return_var=0;
		$s=exec($command,$output,$return_var);
		
		array_push ($output, "EXEC RETURN VALUE : " . $return_var);
		$s=$this->arrayToString($output);
		
		//if (!file_exists($swfFilePath)) return $s;
		return $s;
	}
	
	
	/**
	* Methode pour dterminer si le fichier PDF est plus rcent que le fichier SWF
	* @param string $pdfFilePath chemin complet du fixhier PDF
	* @param string $swfFilePath chemin complet du fixhier SWF
	* @return boolean "true" si le fihier SWF est inexistant ou si le PDF est plus rcent que la SWF, "false" sinon.
	*/
	function isPdfNewer($pdfFilePath,$swfFilePath)
	{
		if (!file_exists($swfFilePath)) {
			return true;
		} else {
			if (filemtime($pdfFilePath)>filemtime($swfFilePath)) return true;
		}
		return false;
	}
	
	/**
	* Transforme un simple tableau en une chane d'lments avec retour  la ligne
	* @param array $result_array le tableau  traiter
	* @return String la chane reprsentant le tableau "aplati"
	*/
	function arrayToString($result_array) {
		reset($result_array);
		$s="";
		$itemNo=0;
		$total=count($result_array);
		while ($array_cell=each($result_array)) {
			$itemNo++;
			if ($itemNo<30) {
				$s .= "->" . $array_cell['value'] . chr(10) ;
			} else if ($itemNo>$total-30) {
				$s .= "->" . $array_cell['value'] . chr(10) ;
			} else if ($itemNo==30) {
				$s .= chr(10) . "... ... ... ... ... ... ... ... ... ..." . chr(10) . chr(10);
			}
		}
		return $s;
	}
	
}

?>